------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Abstract_Scroll_Areas;
with Qt4.Colors;
with Qt4.Fonts;
limited with Qt4.Menus;
with Qt4.Points;
with Qt4.Rects;
with Qt4.Strings;
with Qt4.Text_Char_Formats;
with Qt4.Text_Cursors;
limited with Qt4.Text_Documents;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Text_Edits is

   type Text_Edit_Line_Wrap_Mode is
    (No_Wrap,
     Widget_Width,
     Fixed_Pixel_Width,
     Fixed_Column_Width);
   pragma Convention (C, Text_Edit_Line_Wrap_Mode);

   type Q_Text_Edit is limited interface
     and Qt4.Abstract_Scroll_Areas.Q_Abstract_Scroll_Area;

   type Q_Text_Edit_Access is
     access all Q_Text_Edit'Class;
   for Q_Text_Edit_Access'Storage_Size use 0;

   type Q_Text_Edit_Pointer is tagged;

   procedure Set_Document
    (Self : not null access Q_Text_Edit'Class;
     Document : not null access Qt4.Text_Documents.Q_Text_Document'Class);

   function Document
    (Self : not null access constant Q_Text_Edit'Class)
       return not null access Qt4.Text_Documents.Q_Text_Document'Class;

   procedure Set_Text_Cursor
    (Self : not null access Q_Text_Edit'Class;
     Cursor : Qt4.Text_Cursors.Q_Text_Cursor);

   function Text_Cursor
    (Self : not null access constant Q_Text_Edit'Class)
       return Qt4.Text_Cursors.Q_Text_Cursor;

   function Is_Read_Only
    (Self : not null access constant Q_Text_Edit'Class)
       return Standard.Boolean;

   procedure Set_Read_Only
    (Self : not null access Q_Text_Edit'Class;
     Ro : Standard.Boolean);

   function Font_Point_Size
    (Self : not null access constant Q_Text_Edit'Class)
       return Qt4.Q_Real;

   function Font_Family
    (Self : not null access constant Q_Text_Edit'Class)
       return Qt4.Strings.Q_String;

   function Font_Weight
    (Self : not null access constant Q_Text_Edit'Class)
       return Qt4.Q_Integer;

   function Font_Underline
    (Self : not null access constant Q_Text_Edit'Class)
       return Standard.Boolean;

   function Font_Italic
    (Self : not null access constant Q_Text_Edit'Class)
       return Standard.Boolean;

   function Text_Color
    (Self : not null access constant Q_Text_Edit'Class)
       return Qt4.Colors.Q_Color;

   function Current_Font
    (Self : not null access constant Q_Text_Edit'Class)
       return Qt4.Fonts.Q_Font;

   procedure Merge_Current_Char_Format
    (Self : not null access Q_Text_Edit'Class;
     Modifier : Qt4.Text_Char_Formats.Q_Text_Char_Format'Class);

   procedure Set_Current_Char_Format
    (Self : not null access Q_Text_Edit'Class;
     Format : Qt4.Text_Char_Formats.Q_Text_Char_Format'Class);

   function Tab_Changes_Focus
    (Self : not null access constant Q_Text_Edit'Class)
       return Standard.Boolean;

   procedure Set_Tab_Changes_Focus
    (Self : not null access Q_Text_Edit'Class;
     B : Standard.Boolean);

   procedure Set_Document_Title
    (Self : not null access Q_Text_Edit'Class;
     Title : Qt4.Strings.Q_String);

   function Document_Title
    (Self : not null access constant Q_Text_Edit'Class)
       return Qt4.Strings.Q_String;

   function Is_Undo_Redo_Enabled
    (Self : not null access constant Q_Text_Edit'Class)
       return Standard.Boolean;

   procedure Set_Undo_Redo_Enabled
    (Self : not null access Q_Text_Edit'Class;
     Enable : Standard.Boolean);

   function Line_Wrap_Mode
    (Self : not null access constant Q_Text_Edit'Class)
       return Qt4.Text_Edits.Text_Edit_Line_Wrap_Mode;

   procedure Set_Line_Wrap_Mode
    (Self : not null access Q_Text_Edit'Class;
     Mode : Qt4.Text_Edits.Text_Edit_Line_Wrap_Mode);

   function Line_Wrap_Column_Or_Width
    (Self : not null access constant Q_Text_Edit'Class)
       return Qt4.Q_Integer;

   procedure Set_Line_Wrap_Column_Or_Width
    (Self : not null access Q_Text_Edit'Class;
     W : Qt4.Q_Integer);

   function To_Plain_Text
    (Self : not null access constant Q_Text_Edit'Class)
       return Qt4.Strings.Q_String;

   function To_Html
    (Self : not null access constant Q_Text_Edit'Class)
       return Qt4.Strings.Q_String;

   procedure Ensure_Cursor_Visible
    (Self : not null access Q_Text_Edit'Class);

   function Create_Standard_Context_Menu
    (Self : not null access Q_Text_Edit'Class)
       return not null access Qt4.Menus.Q_Menu'Class;

   function Cursor_For_Position
    (Self : not null access constant Q_Text_Edit'Class;
     Pos : Qt4.Points.Q_Point)
       return Qt4.Text_Cursors.Q_Text_Cursor;

   function Cursor_Rect
    (Self : not null access constant Q_Text_Edit'Class;
     Cursor : Qt4.Text_Cursors.Q_Text_Cursor)
       return Qt4.Rects.Q_Rect;

   function Cursor_Rect
    (Self : not null access constant Q_Text_Edit'Class)
       return Qt4.Rects.Q_Rect;

   function Anchor_At
    (Self : not null access constant Q_Text_Edit'Class;
     Pos : Qt4.Points.Q_Point)
       return Qt4.Strings.Q_String;

   function Overwrite_Mode
    (Self : not null access constant Q_Text_Edit'Class)
       return Standard.Boolean;

   procedure Set_Overwrite_Mode
    (Self : not null access Q_Text_Edit'Class;
     Overwrite : Standard.Boolean);

   function Tab_Stop_Width
    (Self : not null access constant Q_Text_Edit'Class)
       return Qt4.Q_Integer;

   procedure Set_Tab_Stop_Width
    (Self : not null access Q_Text_Edit'Class;
     Width : Qt4.Q_Integer);

   function Cursor_Width
    (Self : not null access constant Q_Text_Edit'Class)
       return Qt4.Q_Integer;

   procedure Set_Cursor_Width
    (Self : not null access Q_Text_Edit'Class;
     Width : Qt4.Q_Integer);

   function Accept_Rich_Text
    (Self : not null access constant Q_Text_Edit'Class)
       return Standard.Boolean;

   procedure Set_Accept_Rich_Text
    (Self : not null access Q_Text_Edit'Class;
     Acc : Standard.Boolean);

   function Can_Paste
    (Self : not null access constant Q_Text_Edit'Class)
       return Standard.Boolean;

   procedure Set_Font_Point_Size
    (Self : not null access Q_Text_Edit'Class;
     S : Qt4.Q_Real);

   procedure Set_Font_Family
    (Self : not null access Q_Text_Edit'Class;
     Font_Family : Qt4.Strings.Q_String);

   procedure Set_Font_Weight
    (Self : not null access Q_Text_Edit'Class;
     Weight : Qt4.Q_Integer);

   procedure Set_Font_Underline
    (Self : not null access Q_Text_Edit'Class;
     Underline : Standard.Boolean);

   procedure Set_Font_Italic
    (Self : not null access Q_Text_Edit'Class;
     Italic : Standard.Boolean);

   procedure Set_Text_Color
    (Self : not null access Q_Text_Edit'Class;
     C : Qt4.Colors.Q_Color);

   procedure Set_Current_Font
    (Self : not null access Q_Text_Edit'Class;
     F : Qt4.Fonts.Q_Font);

   procedure Set_Plain_Text
    (Self : not null access Q_Text_Edit'Class;
     Text : Qt4.Strings.Q_String);

   procedure Set_Html
    (Self : not null access Q_Text_Edit'Class;
     Text : Qt4.Strings.Q_String);

   procedure Set_Text
    (Self : not null access Q_Text_Edit'Class;
     Text : Qt4.Strings.Q_String);

   procedure Cut
    (Self : not null access Q_Text_Edit'Class);

   procedure Copy
    (Self : not null access Q_Text_Edit'Class);

   procedure Paste
    (Self : not null access Q_Text_Edit'Class);

   procedure Undo
    (Self : not null access Q_Text_Edit'Class);

   procedure Redo
    (Self : not null access Q_Text_Edit'Class);

   procedure Clear
    (Self : not null access Q_Text_Edit'Class);

   procedure Select_All
    (Self : not null access Q_Text_Edit'Class);

   procedure Insert_Plain_Text
    (Self : not null access Q_Text_Edit'Class;
     Text : Qt4.Strings.Q_String);

   procedure Insert_Html
    (Self : not null access Q_Text_Edit'Class;
     Text : Qt4.Strings.Q_String);

   procedure Append
    (Self : not null access Q_Text_Edit'Class;
     Text : Qt4.Strings.Q_String);

   procedure Scroll_To_Anchor
    (Self : not null access Q_Text_Edit'Class;
     Name : Qt4.Strings.Q_String);

   procedure Zoom_In
    (Self : not null access Q_Text_Edit'Class;
     Rng : Qt4.Q_Integer
       :=  1);

   procedure Zoom_Out
    (Self : not null access Q_Text_Edit'Class;
     Rng : Qt4.Q_Integer
       :=  1);

   package Q_Text_Edit_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Text_Edit, Q_Text_Edit_Access);

   type Q_Text_Edit_Pointer is
     new Q_Text_Edit_Pointers.Q_Pointer with null record;

end Qt4.Text_Edits;
